#include <stdio.h>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_odeiv.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_multimin.h>

/* rank of pfaffian system */
#define N_VALUES 6

#define DIM 9

/* ʬ򤯥르ꥺ */
#define ODEIV_STEP_TYPE gsl_odeiv_step_rkf45

/* return value of the function move_t */
#define MOVE_T_SUCCESS 1  
#define MOVE_T_FAIL    0

/* ǾΥ르ꥺ */
/* #define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fdfminimizer_steepest_descent  */
/*#define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fminimizer_nmsimplex2 */
/*#define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fdfminimizer_vector_bfgs */
#define MULTIMIN_FDFMINIMIZER_TYPE gsl_multimin_fdfminimizer_conjugate_fr  



gsl_matrix *a1, *b1, *c1, *e1;
gsl_matrix *a2, *b2, *c2, *e2;
gsl_matrix *a3, *b3, *c3, *e3;
gsl_matrix *p2, *q2, *p3, *q3, *r3;
gsl_matrix *db11;
gsl_matrix *dc11;
gsl_matrix *db12;
gsl_matrix *dc12;
gsl_matrix *db13;
gsl_matrix *dc13;
gsl_matrix *db21;
gsl_matrix *dc21;
gsl_matrix *db22;
gsl_matrix *dc22;
gsl_matrix *db23;
gsl_matrix *dc23;
gsl_matrix *db31;
gsl_matrix *dc31;
gsl_matrix *db32;
gsl_matrix *dc32;
gsl_matrix *db33;
gsl_matrix *dc33;
gsl_matrix *dq21;
gsl_matrix *dq31;
gsl_matrix *dr31;
gsl_matrix *dq22;
gsl_matrix *dq32;
gsl_matrix *dr32;
gsl_matrix *dq23;
gsl_matrix *dq33;
gsl_matrix *dr33;
gsl_matrix *inv_a1;
gsl_matrix *inv_a2;
gsl_matrix *inv_a3;
gsl_matrix *inv_p2;
gsl_matrix *inv_p3;
gsl_matrix *pf1_m;
gsl_matrix *pf2_m;
gsl_matrix *pf3_m;
gsl_matrix *pf11_m;
gsl_matrix *pf12_m;
gsl_matrix *pf13_m;
gsl_matrix *pf22_m;
gsl_matrix *pf23_m;
gsl_matrix *pf33_m;
gsl_matrix *pft_m;
gsl_vector *grad_v;
double g_s11, g_s12, g_s13, g_s22, g_s23, g_s33, g_s1, g_s2, g_s3;
double g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, g_r;
double values[N_VALUES];
double move_t_points[DIM];

void set_abce_1(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void set_abce_2(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void set_abce_3(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void set_pqr(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void set_dbcqr(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf1(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf1_no_diag_shift(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf2(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf2_no_diag_shift(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf3(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf3_no_diag_shift(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf11(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf12(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf13(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf22(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf23(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void pf33(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r);
void invmat(gsl_matrix *m, gsl_matrix *invm);
void gsl_matrix_show(gsl_matrix *mat);

double my_f(const gsl_vector *v, void *params);
void my_df(const gsl_vector *v, void *param, gsl_vector *df);
void my_fdf(const gsl_vector *x, void *params, double *f, gsl_vector *df);
void gsl_vector_show(gsl_vector *v);
void grad(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r, double *val);
int move_t(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double xx11, double xx12, double xx13, double xx22, double xx23, double xx33, double yy1, double yy2, double yy3, double *val);
int sys_t(double t, const double *y, double *val, double *params);

double *init_val (double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double s11, double s12, double s13, double s22, double s23, double s33, double s1, double s2, double s3);


